/*
 * audio_buffer.c
 *
 *  Created on: 19.12.2017
 *      Author: TheMason
 */


#include "stm32f4xx_hal.h"

#include <stdio.h>
#include <string.h>
#include <math.h>


#include "audio_buffer.h"






  #define AUDIO_FUNC(x)    ((int16_t) (4095.0f * sin ((x) * 6.2831853f / 4096.0f)))
  //#define AUDIO_FUNC(x)    ((int16_t) ((x & 0xfff) << 1) - 0x1000)
  //#define AUDIO_FUNC(x)    ((int16_t) (x & 0x800) ? 0x1000 : -0x1000)
  //#define AUDIO_FUNC(x)    ((int16_t) (0))


  #define AUDIO_X_000(x, y)   AUDIO_FUNC ( (x | y))

  #define AUDIO_X_00X(x, y)      \
      AUDIO_X_000 (x, 0x000 | y), AUDIO_X_000 (x, 0x001 | y), AUDIO_X_000 (x, 0x002 | y), AUDIO_X_000 (x, 0x003 | y), \
      AUDIO_X_000 (x, 0x004 | y), AUDIO_X_000 (x, 0x005 | y), AUDIO_X_000 (x, 0x006 | y), AUDIO_X_000 (x, 0x007 | y), \
      AUDIO_X_000 (x, 0x008 | y), AUDIO_X_000 (x, 0x009 | y), AUDIO_X_000 (x, 0x00a | y), AUDIO_X_000 (x, 0x00b | y), \
      AUDIO_X_000 (x, 0x00c | y), AUDIO_X_000 (x, 0x00d | y), AUDIO_X_000 (x, 0x00e | y), AUDIO_X_000 (x, 0x00f | y)  \

  #define AUDIO_X_0X0(x, y)      \
      AUDIO_X_00X (x, 0x000 | y), AUDIO_X_00X (x, 0x010 | y), AUDIO_X_00X (x, 0x020 | y), AUDIO_X_00X (x, 0x030 | y), \
      AUDIO_X_00X (x, 0x040 | y), AUDIO_X_00X (x, 0x050 | y), AUDIO_X_00X (x, 0x060 | y), AUDIO_X_00X (x, 0x070 | y), \
      AUDIO_X_00X (x, 0x080 | y), AUDIO_X_00X (x, 0x090 | y), AUDIO_X_00X (x, 0x0a0 | y), AUDIO_X_00X (x, 0x0b0 | y), \
      AUDIO_X_00X (x, 0x0c0 | y), AUDIO_X_00X (x, 0x0d0 | y), AUDIO_X_00X (x, 0x0e0 | y), AUDIO_X_00X (x, 0x0f0 | y)  \

  #define AUDIO_X_X00(x, y)      \
      AUDIO_X_0X0 (x, 0x000 | y), AUDIO_X_0X0 (x, 0x100 | y), AUDIO_X_0X0 (x, 0x200 | y), AUDIO_X_0X0 (x, 0x300 | y), \
      AUDIO_X_0X0 (x, 0x400 | y), AUDIO_X_0X0 (x, 0x500 | y), AUDIO_X_0X0 (x, 0x600 | y), AUDIO_X_0X0 (x, 0x700 | y), \
      AUDIO_X_0X0 (x, 0x800 | y), AUDIO_X_0X0 (x, 0x900 | y), AUDIO_X_0X0 (x, 0xa00 | y), AUDIO_X_0X0 (x, 0xb00 | y), \
      AUDIO_X_0X0 (x, 0xc00 | y), AUDIO_X_0X0 (x, 0xd00 | y), AUDIO_X_0X0 (x, 0xe00 | y), AUDIO_X_0X0 (x, 0xf00 | y)  \




uint32_t  dma_buffer  [BUFFER_SIZE];

uint32_t  out_buffers [NUM_BUFFERS][BUFFER_SIZE];

uint32_t  play_buffer     = 0;
uint32_t  work_buffer     = 0;
uint32_t  buffer_request  = 0;
uint32_t *work_buf        = NULL;
uint32_t  smp_cnt         = 0;



const int16_t sintab [4096] = {
    AUDIO_X_X00 (0, 0),
};




void StartAudioBuffers (void)
{
  memset (dma_buffer,   0, sizeof (dma_buffer ));
  memset (out_buffers,  0, sizeof (out_buffers));

  FillBuffer (dma_buffer, BUFFER_SIZE);

  HAL_I2S_Transmit_DMA (&hi2s2, (uint16_t *) dma_buffer, BUFFER_SIZE << 1);

  smp_cnt         = 0;

}

void SwapAudioBuffer (void)
{
  play_buffer = work_buffer;
  work_buffer = (work_buffer + 1) == NUM_BUFFERS ? 0 : work_buffer + 1;

  buffer_request = 1;
  work_buf = &(out_buffers [work_buffer][0]);

  memcpy (dma_buffer, &(out_buffers [play_buffer][0]), sizeof (dma_buffer));
}


uint8_t HandleAudioBuffer (void)
{
  if (buffer_request)
  {
    buffer_request = 0;
    return 1;
  }
  return 0;
}

uint32_t *GetAudioBuffer (void)
{
  return work_buf;
}

uint32_t GetNumAudioSamples (void)
{
  return smp_cnt;
}


void HAL_I2S_TxCpltCallback(I2S_HandleTypeDef *hi2s)
{
  SwapAudioBuffer ();
  smp_cnt += BUFFER_SIZE;
}
